#!/usr/bin/perl
use strict;
use warnings;
#use integer;
my $version="5e";
my $correct_ImageMagick_version = "6.3.5";
#----------------------------------------
#Variables
#----------------------------------------
#Do you want debugging reports turned on? If this is a mystery to you then you don't want it on.
my $DEBUG=0;
my $num_of_arg;
my $x; my $y=0;
my @array;
my $black; my $white;
my $input_file; 
#This is the default white value. It is about grey29 or grey30 on a 256 greyscale.
#Should delete this default value. In essense it has been removed.
my $which_white=72;
my @spreadsheet_array;
my $column; my $row;
my $max_column=0; my $max_row=0;
my $header="";
#$cell_number is the current cell that we are working with.
my $cell_number;

#@ARGV is an array that contains all of the command-line arguments.
#If it is empty, the test will fail, a suggestion will print and the program will exit.
#Use !=0 if you want just one argument. Use <1 is you want no fewer than 2 arguments.
#Use < 0 if you want 1 or more arguments.  Zero arguments gives a $#ARGV = -1.
# <3 means at least 4 arguments.
#This is how we handle wildcards. We let Bash handle the expansion of filenames.
#We just read them from $ARGV[];
if($#ARGV <1)
{
	print "\n\n\n\n";
	print "|----------------------------------August 6,2007-------------------------------------|\n";
	print " version#$version\n";
	print " I expect version $correct_ImageMagick_version of the ImageMagick tools\n\n";
	print " Use me like this: $0 [white_value_to_use] [image_names(s)]\n";
	print " 128 is usually the best value. 72 is the minimal that we ever use.\n";
	print " This is the lowest value of white that you want me to record.\n";
	print " Bigger numbers are more white, smaller numbers are more black\n";
	print " I will count the amount of white between white_value_to_use and pure white.\n\n";
	print " I expect that the image will be a 256 grey scale image\n";
	print " I will return the amount of white.\n\n";
	print " I will store the data in a file called results.txt.\n";
	print " Be careful because I will overwrite any pre-exisiting file with this name\n";
	print " $0 [white_value_to_use] [image_name(s)]\n";
	print " I acccept wild cards, but not Visa or Mastercard.\n";
	print "|--------------------------------by Nigel Atkinson-----------------------------------|\n";
	exit; 
}
else
{
	print "version#$version\n";
}

my $version_checker=`identify -version`;
#Data looks like this:
#Version: ImageMagick 6.3.5 07/28/07 Q16 http://www.imagemagick.org
if($version_checker=~/Version: ImageMagick (\S+)/)
	{
		if($correct_ImageMagick_version ne $1)
		{
			print "This script expects ImageMagick version $correct_ImageMagick_version.\n";
			print "You are using version $1\n";
			print "Contact Nigel Atkinson to get an updated script.\n";
			exit;
		}
	}
else
	{
		print "I cannot determine the ImageMagick version.\n";
		print "I expect that the command \"identify -version\" will return the version number\n";
		print "Contact Nigel Atkinson to get an updated script.\n";
		exit;
	}	

#----------------------------------------------------
#open the outputfile which will store the spreadsheet
#This will be a tab delimited text file.
my $output_file;
$output_file="results.txt";
unless(open(OUTPUTFILE,">$output_file"))
{
	print("\ncannot open $output_file\n");
	exit;
}
#----------------------------------------------------
$num_of_arg = @ARGV;

#We need to delete this. It is an archiaeological relic and should be removed.
#If we have provided a grey value then use it, if not then use the default.
if($ARGV[0]>0)
{
	$which_white=$ARGV[0];
}

#Print the column names for the Openoffice or Excel spreadsheet file.
print "image\twhite\n";

$column="";
#File names begin with the second entry on the command line.
for($x=1;$x<$num_of_arg;$x++)
{
	$input_file=$ARGV[$x];
	#Decided to skip the monochroming. Greyscale gives less noise.
	#print `convert -monochrome $input_file $output_file`;

	#Data looks like this: cell_001.00002.jpg
	print "input_file=$input_file\n";
	if($input_file=~/cell_(\d+).(\d+).jpg/)
	{
		$column=$1;
		$row=$2;
		if ($column > $max_column)
		{
			$max_column=$column;
		}
		if ($row > $max_row)
		{
			$max_row=$row;
		}
	}	
	
	@array=`identify -verbose $input_file`;
	$white=0; $black=0;

	for($y=0; $y<@array; $y++)
	{
		#This is what the data looks like (output of quantify -verbose
  		#Histogram:
     		#12316: (  6,  6,  6) #060606 rgb(6,6,6)
     		#10940: (  3,  3,  3) #030303 grey1
       		#953: ( 16, 16, 16) #101010 rgb(16,16,16)
        	#42: (103,103,103) #676767 rgb(103,103,103)
        	#42: (164,164,164) #A4A4A4 rgb(164,164,164)
		
		if($array[$y]=~/\s*(\d+): \(\s*(\d+),\s*(\d+),/)
		{ 
			#Now collect all of the greys that we want to call white.
			#First guess was 72
			if($2>=$which_white)
			{
				$white=$white+$1;
			}
		}
                if($array[$y+1]=~/\s*Colormap/)
		{
			#last;
			$y=@array;
		}
	}
	
	#$cell_number is how we want each column in the spreadsheet to begin.
	#It would be nice to store this in an 2 dim array.
	#spreadsheet_array[column][row] where the columns are different cells and the row are differnt times.
	$spreadsheet_array[$column][$row]= "$white";
	$spreadsheet_array[$column][0]="cell_$column";
}

my $print_row; my $print_col;
print "-------------------------------------------------------------------\n";
print "Total number of rows=$max_row, of columns=$max_column\n";
for $print_row(0 .. $max_row)
{
	for $print_col(0 .. $max_column)
	{
		print $spreadsheet_array[$print_col][$print_row]."\t";
		print OUTPUTFILE $spreadsheet_array[$print_col][$print_row]."\t";
	}
	print "\n";
	print OUTPUTFILE "\n";
}

print "Data has been stored in column format in $output_file\n";
exit;

